package org.objectweb.telosys.tunit;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.security.Principal;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Locale;
import java.util.Map;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletInputStream;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.objectweb.telosys.common.TelosysClassLogger;

public class FakeHttpServletRequest implements HttpServletRequest 
{
    private static final TelosysClassLogger log = new TelosysClassLogger(FakeHttpServletRequest.class);
	
	private Hashtable attributes = new Hashtable();
	
	private FakeHttpSessionManager sessionManager = null ;
	
	//private HttpSession httpSession = null ;

	
	public FakeHttpServletRequest() {
		super();
		log.trace("FakeHttpServletRequest()...");
		this.sessionManager = new FakeHttpSessionManager() ;
		log.trace("new FakeHttpServletRequest created.");
	}
	
	public FakeHttpServletRequest(FakeHttpSessionManager sessionManager) {
		super();
		log.trace("FakeHttpServletRequest(sessionManager)...");
		if ( sessionManager != null )
		{
			this.sessionManager = sessionManager;
		}
		else
		{
			this.sessionManager = new FakeHttpSessionManager() ;
		}
		log.trace("new FakeHttpServletRequest created.");
	}

	//------------------------------------------------------------------------
	// HttpSession management
	//------------------------------------------------------------------------
	public HttpSession getSession() 
	{
		log.trace("getSession()...");
		return this.sessionManager.getSession() ;
	}

	public HttpSession getSession(boolean flag) 
	{
		log.trace("getSession("+flag+")...");
		return this.sessionManager.getSession(flag) ;
	}

	//------------------------------------------------------------------------
	// Attributes management
	//------------------------------------------------------------------------
	public void setAttribute(String key, Object value) 
	{
		attributes.put(key, value);
	}

	public Object getAttribute(String key) 
	{
		return attributes.get(key);
	}
	public void removeAttribute(String key) 
	{
		attributes.remove(key);	
	}

	public Enumeration getAttributeNames() {
		return attributes.keys();
	}

	//------------------------------------------------------------------------
	// URL
	//------------------------------------------------------------------------

	public StringBuffer getRequestURL() {
		return new StringBuffer( "http://localhost:8080/unittest/action" ) ;
	}

	public String getRequestURI() {
		return "/unittest/action";
	}

	public String getContextPath() {
		return "/unittest";
	}

	public String getServletPath() {
		return "/action"; // Default URL for screen action request
	}

	public String getPathInfo() {
		return null; // Nothing after "/action"
	}

	public String getQueryString() 
	{
		return null; // No query string
	}
	
	public String getScheme() {
		return "http";
	}

	public String getServerName() {
		return "localhost";
	}

	public int getServerPort() {
		return 8080;
	}

	//------------------------------------------------------------------------
	public String getProtocol() {
		return "HTTP/1.1";
	}

	public String getMethod() {
		return "POST";
	}

	//------------------------------------------------------------------------
	//------------------------------------------------------------------------

	public String getAuthType() {
		// TODO Auto-generated method stub
		return null;
	}

	public Cookie[] getCookies() {
		// TODO Auto-generated method stub
		return null;
	}

	public long getDateHeader(String arg0) {
		// TODO Auto-generated method stub
		return 0;
	}

	public String getHeader(String arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	public Enumeration getHeaderNames() {
		// TODO Auto-generated method stub
		return null;
	}

	public Enumeration getHeaders(String arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	public int getIntHeader(String arg0) {
		// TODO Auto-generated method stub
		return 0;
	}

	public String getPathTranslated() {
		// TODO Auto-generated method stub
		return null;
	}


	public String getRemoteUser() {
		// TODO Auto-generated method stub
		return null;
	}

	public String getRequestedSessionId() {
		// TODO Auto-generated method stub
		return null;
	}

	public Principal getUserPrincipal() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean isRequestedSessionIdFromCookie() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isRequestedSessionIdFromUrl() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isRequestedSessionIdFromURL() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isRequestedSessionIdValid() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isUserInRole(String arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	public String getCharacterEncoding() {
		// TODO Auto-generated method stub
		return null;
	}

	public int getContentLength() {
		// TODO Auto-generated method stub
		return 0;
	}

	public String getContentType() {
		// TODO Auto-generated method stub
		return null;
	}

	public ServletInputStream getInputStream() throws IOException {
		// TODO Auto-generated method stub
		return null;
	}

	public String getLocalAddr() {
		// TODO Auto-generated method stub
		return null;
	}

	public Locale getLocale() {
		// TODO Auto-generated method stub
		return null;
	}

	public Enumeration getLocales() {
		// TODO Auto-generated method stub
		return null;
	}

	public String getLocalName() {
		// TODO Auto-generated method stub
		return null;
	}

	public int getLocalPort() {
		// TODO Auto-generated method stub
		return 0;
	}

	public String getParameter(String arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	public Map getParameterMap() {
		// TODO Auto-generated method stub
		return null;
	}

	public Enumeration getParameterNames() {
		// TODO Auto-generated method stub
		return null;
	}

	public String[] getParameterValues(String arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	public BufferedReader getReader() throws IOException {
		// TODO Auto-generated method stub
		return null;
	}

	public String getRealPath(String arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	public String getRemoteAddr() {
		// TODO Auto-generated method stub
		return null;
	}

	public String getRemoteHost() {
		// TODO Auto-generated method stub
		return null;
	}

	public int getRemotePort() {
		// TODO Auto-generated method stub
		return 0;
	}

	public RequestDispatcher getRequestDispatcher(String arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean isSecure() {
		// TODO Auto-generated method stub
		return false;
	}

	public void setCharacterEncoding(String arg0)
			throws UnsupportedEncodingException {
		// TODO Auto-generated method stub
		
	}

}
